void rgbmatrix(unsigned char buf_vram[],unsigned char vram[],int posx,int posy,int sizex,int sizey,int winx,int winy,int rgb[],int offset[])
{
	int vramp;
	int px_min = posx		,py_min = posy		;
	int px_max = posx+sizex	,py_max = posy+sizey;
	int px = posx			,py = posy			;
	int vramx = winx*3		,vramy = winy		;
	int r,g,b;
	if (px_max<0){px_max=0;} if (px_max>winx){px_max=winx;}
	if (py_max<0){py_max=0;} if (py_max>winy){py_max=winy;}
	if (px_min<0){px_min=0;} if (px_min>winx){px_min=winx;}
	if (py_min<0){py_min=0;} if (py_min>winy){py_min=winy;}
	vramx = (vramx + 3) & 0xFFFFFFFC;
	for (py = py_min ; py < py_max ; py++ ){
		vramp = (vramy-py)*vramx-(vramx-px_min*3);
		for (px = px_min ; px < px_max ; px++ ){
			r = buf_vram[vramp+2]*rgb[0] + buf_vram[vramp+1]*rgb[1] + buf_vram[vramp  ]*rgb[2];
			g = buf_vram[vramp+2]*rgb[3] + buf_vram[vramp+1]*rgb[4] + buf_vram[vramp  ]*rgb[5];
			b = buf_vram[vramp+2]*rgb[6] + buf_vram[vramp+1]*rgb[7] + buf_vram[vramp  ]*rgb[8];
			r  += 0x8000;
			r >>= 16;
			g +=  0x8000;
			g >>= 16;
			b  += 0x8000;
			b >>= 16;
			if(offset != 0) {
				r += offset[0];
				g += offset[1];
				b += offset[2];
			}
			if(r<0)		{r=0;}
			if(r>255)	{r=255;}
			if(g<0)		{g=0;}
			if(g>255)	{g=255;}
			if(b<0)		{b=0;}
			if(b>255)	{b=255;}
			vram[vramp+2] = r;
			vram[vramp+1] = g;
			vram[vramp  ] = b;
			vramp+=3;
		}
	}
}
