void filter(unsigned char buf_vram[],unsigned char vram[],int posx,int posy,int sizex,int sizey,int winx,int winy,int fsizex,int fsizey,int rfilter[],int gfilter[],int bfilter[],int roffset,int goffset,int boffset,int fch)
{
	int vramp1,vramp2;
	int px_min = posx		,py_min = posy		;
	int px_max = posx+sizex	,py_max = posy+sizey;
	int px = posx			,py = posy			;
	int firx				,firy				;
	int vramx = winx*3		,vramy = winy		;
	int fpx,fpy;
	int fbufx1  = fsizex >> 1,fbufy1  = fsizey >> 1,fbufxmax,fbufymax;
	int fsizex2 = fsizex -  1,fsizey2 = fsizey - 1;
	int fcnt,wr,wg,wb,offr,offg,offb;
	offr = roffset << 16;
	offg = goffset << 16;
	offb = boffset << 16;
	if (px_max<0){px_max=0;}if (px_max>winx){px_max=winx;}
	if (py_max<0){py_max=0;}if (py_max>winy){py_max=winy;}
	if (px_min<0){px_min=0;}if (px_min>winx){px_min=winx;}
	if (py_min<0){py_min=0;}if (py_min>winy){py_min=winy;}
	if (gfilter==0){gfilter=rfilter;}
	if (bfilter==0){bfilter=rfilter;}
	vramx = (vramx + 3) & 0xFFFFFFFC;
	for (py = py_min ; py < py_max ; py++ ){
		vramp1 = (vramy-py)*vramx-(vramx-px_min*3);
		for (px = px_min ; px < px_max ; px++ ){
			fcnt = 0;
			wr = offr;
			wg = offg;
			wb = offb;
			fbufxmax = px + fbufx1;
			fbufymax = py + fbufy1;
			for (fpy = fbufymax - fsizey2 ; fpy <= fbufymax ; fpy++){
				for (fpx = fbufxmax - fsizex2 ; fpx <= fbufxmax ; fpx++){
					firx=fpx;firy=fpy;
					if (!fch){
						if (firx<px_min){firx=px_min;}else if (firx>=px_max){firx=px_max-1;}
						if (firy<py_min){firy=py_min;}else if (firy>=py_max){firy=py_max-1;}
					}else{
						if (firx<0){firx=0;}else if (firx>=winx){firx=winx-1;}
						if (firy<0){firy=0;}else if (firy>=winy){firy=winy-1;}
					}
					vramp2 = (vramy-firy)*vramx-(vramx-firx*3);
					wb += buf_vram[vramp2  ] * rfilter[fcnt];
					wg += buf_vram[vramp2+1] * gfilter[fcnt];
					wr += buf_vram[vramp2+2] * bfilter[fcnt];
					fcnt++;
				}
			}
			if (wb<0){wb=0;}wb+=0x8000;wb>>=16;
			if (wb>255){wb=255;}vram[vramp1  ]=wb;
			if (wg<0){wg=0;}wg+=0x8000;wg>>=16;
			if (wg>255){wg=255;}vram[vramp1+1]=wg;
			if (wr<0){wr=0;}wr+=0x8000;wr>>=16;
			if (wr>255){wr=255;}vram[vramp1+2]=wr;
			vramp1+=3;
		}
	}
}
