void rgbtable(unsigned char buf_vram[],unsigned char vram[],int posx,int posy,int sizex,int sizey,int winx,int winy,unsigned char redtable[],unsigned char greentable[],unsigned char bluetable[])
{
	int vramp;
	int px_min = posx		,py_min = posy		;
	int px_max = posx+sizex	,py_max = posy+sizey;
	int px = posx			,py = posy			;
	int vramx = winx*3		,vramy = winy		;
	if (px_max<0){px_max=0;}if (px_max>winx){px_max=winx;}
	if (py_max<0){py_max=0;}if (py_max>winy){py_max=winy;}
	if (px_min<0){px_min=0;}if (px_min>winx){px_min=winx;}
	if (py_min<0){py_min=0;}if (py_min>winy){py_min=winy;}
	if (greentable==0){greentable = redtable;}
	if (bluetable==0){bluetable = redtable;}
	vramx = (vramx + 3) & 0xFFFFFFFC;
	for (py = py_min ; py < py_max ; py++ ){
		vramp = (vramy-py)*vramx-(vramx-px_min*3);
		for (px = px_min ; px < px_max ; px++ ){
			vram[vramp  ] = bluetable[ buf_vram[vramp ]];
			vram[vramp+1] = greentable[buf_vram[vramp+1]];
			vram[vramp+2] = redtable[  buf_vram[vramp+2]];
			vramp+=3;
		}
	}
}
